import npyscreen
from Emitter import Emitter

class ChatUI(npyscreen.Form):
    def create(self):
        super(ChatUI, self).create()
        self.messages = self.add(npyscreen.Pager, rely=2, relx=1, width=self.max_x - 1, height=self.max_y - 10,
                            max_width=self.max_x - 18, max_height=self.max_y - 10, editable=0, color="CURSOR",
                            widgets_inherit_color=True)
        self.message = self.add(npyscreen.TitleText, name = 'Messaggio: ')
        self.emitter = Emitter.emitter

        @self.emitter.on('chatMessage')
        def messageHandler(message):
            self.messages.values.append(message)
            self.messages.update()

    def afterEditing(self):
        self.messages.values.append("You " + self.message.value)
        self.emitter.emit('send', (self.message.value, self.parentApp.username, self.parentApp.sessionid))
        self.message.value = ""
