import npyscreen
import requests
from Emitter import Emitter

class LoginForm(npyscreen.Form):
    def create(self):
        super(LoginForm, self).create()
        self.username = self.add(npyscreen.TitleText, name = 'Username: ')
        self.password = self.add(npyscreen.TitlePassword, name = 'Password: ')
        self.emitter = Emitter.emitter
    def afterEditing(self):
        # request for auth
        login = requests.post('https://auth.emilianomaccaferri.com/login', data = {'username': self.username.value, 'password': self.password.value})
        json = login.json()

        if json['success'] == True:
            npyscreen.notify_confirm("Login eseguito correttamente!")
            self.parentApp.username = self.username.value
            self.parentApp.sessionid = json['session']
            self.emitter.emit('logged')
            self.parentApp.setNextForm("CHAT")
        else:
            npyscreen.notify_confirm("Credenziali errate, riprova")
            self.parentApp.setNextForm("MAIN")
