import threading
from ChatChannel import ClientChannelHandler
import socket

class ChannelManager:
    __channels = None
    def __init__(self, config):
        self.config = config
        self.__channels = config
        self.channels = {}

        for channel in self.config:
            t = threading.Thread(daemon = True, args = (channel, self.config[channel]), target = self.__makeChannel)
            t.start()

    def getChannels(self):
        return self.config

    def __makeChannel(self, name, port):
        print("Making {}".format(name))
        self.channels[name] = {"port": port, "enabled": True}
        channelConnection = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        channelConnection.bind(('localhost', port))
        channelConnection.listen(100)

        while self.channels[name]["enabled"]:
            conn, addr = channelConnection.accept()
            print(addr, 'connected')
            t = threading.Thread(target = self.__acceptConnection, args = (conn, addr), daemon = True)
            t.start()
