import threading
from ChannelManager import ChannelManager

class Client(threading.Thread):
    def __init__(self, conn, add, friends, ips, channels, manager):
        self.bad_words = ["python", "banana", "tonno"]
        self.tries = 0
        self.availableChannels = channels
        self.manager = manager
        self.ips = ips
        self.conn = conn
        self.address = add
        self.friends = friends
        self.enabled = True
        self.commands = ["!login", "!join"]
        threading.Thread.__init__(self)
        self.scopes = {
            "global": "[global]",
            "login": "[login]",
            "register": "[register]",
            "logincorrect": "[global]"
        }
        self.currentScope = None

    def __endConnection(self):
        print("bye bye")
        self.conn.close()
        self.friends.pop(self.friends.index(self))
        self.enabled = False

    def run(self):
        while self.enabled == True:
            data = self.conn.recv(1024)
            message = data.decode('utf-8')
            args = message.split(":")
            if len(message.split("|")) < 2:
                self.__endConnection()
                break

            if message.split("|")[1][0] == "!":
                # it's a command, hide it
                cmd = message.split("|")[1]
                print("received command", message)
                if cmd == "!channellist":
                    self.conn.send(self.availableChannels.encode('utf-8'))
                    continue

                if cmd == "!list":
                    ips = ""
                    index = 0
                    for ip in self.ips:
                        if index == self.friends.index(self):
                            ips += ips + ip[0] + " (you) "
                        else:
                            ips += ips + ip[0] + " "
                        index = index + 1

                    self.conn.send(ips.encode('utf-8'))
                    continue

                args = cmd.split(":")
                if args[0] in self.commands:
                    # command exists
                    if args[0] == "!join":
                        try:
                            name = list(self.manager.config)[int(args[1])-1]
                            print("found channel", name)
                            channel = self.manager.config[name]
                            newc = '!newchannel:' + name + ':' + channel
                            self.conn.send(newc.encode('utf-8'))
                            self.conn.close()

                        except IndexError:
                            self.conn.send(b'Canale inesistente')

                    if args[0] == "!login":
                        username = args[1]
                        password = args[2]
                        try:
                            if users[username] == password:
                                self.conn.send(b'Credenziali corrette!')
                                self.setScope("logincorrect", username)
                                self.friends.append(self)
                                for friend in self.friends:
                                    if(friend != self):
                                        msg = username + " joined the chat"
                                        friend.getClient().send(msg.encode('utf-8'))
                                continue
                            else:
                                self.conn.send(b'Password errata')
                        except KeyError:
                            self.conn.send(b'Username non esistente')
                else:
                    self.conn.send(b'Comando non esistente')

            else:
                # not a command
                try:
                    if self.bad_words.index(message.split("|")[1]) != -1:
                    # bad word detected!
                        self.tries += 1
                        msg = "Hey, attenzione al linguaggio! Hai ancora {} possibilita'".format(str(self.tries))
                        self.conn.send(msg.encode('utf-8'))
                        if self.tries == 3:
                            self.__endConnection()
                            break
                        continue
                except ValueError:
                    for friend in self.friends:
                        pieces = message.split("|")
                        if(len(pieces) == 0):
                            continue

                        strToSend = "{} said: {}".format(pieces[0], pieces[1])
                        if(friend != self):
                            friend.getClient().send(strToSend.encode('utf-8'))

    def setScope(self, scope, username = ""):
        if(self.scopes[scope]):
            if(scope == "logincorrect"):
                self.currentScope = self.scopes[scope]
                send = "!logincorrect:"+username+":[global]"
                self.conn.send(send.encode('utf-8'))
            else:
                self.currentScope = self.scopes[scope]
                role = '!newscope:'+self.scopes[scope]
                self.conn.sendall(role.encode('utf-8'))
                return True
        else:
            return False

    def getScope(self):
        return self.currentScope

    def getClient(self):
        return self.conn
