import threading
from ChannelManager import ChannelManager

users = {'macca':'tonno', 'fff':'aaa'}

class Client(threading.Thread):
    def __init__(self, conn, add, friends, channels, manager):
        self.availableChannels = channels
        self.manager = manager
        self.conn = conn
        self.address = add
        self.friends = friends
        self.enabled = True
        self.commands = ["!login", "!join"]
        threading.Thread.__init__(self)
        self.scopes = {
            "global": "[global]",
            "login": "[login]",
            "register": "[register]",
            "logincorrect": "[global]"
        }
        self.currentScope = None

    def run(self):
        while self.enabled == True:
            try:
                data = self.conn.recv(1024)
                message = data.decode('utf-8')
                args = message.split(":")
            except ConnectionResetError:
                continue

            print("MESSAGE: " + str(message))

            if not data or data == "":
                self.conn.close()
                self.friends.pop(self.friends.index(self))
                continue

            if message[0] == "!":
                # it's a command, hide it
                print("received command", message)
                if message == "!channellist":
                    self.conn.send(self.availableChannels.encode('utf-8'))
                    continue

                args = message.split(":")
                if args[0] in self.commands:
                    # command exists
                    if args[0] == "!join":
                        try:
                            name = list(self.manager.config)[int(args[1])-1]
                            print("found channel", name)
                            channel = self.manager.config[name]
                            newc = '!newchannel:' + name + ':' + channel
                            self.conn.send(newc.encode('utf-8'))
                            self.conn.close()

                        except IndexError:
                            self.conn.send(b'Canale inesistente')

                    if args[0] == "!login":
                        username = args[1]
                        password = args[2]
                        try:
                            if users[username] == password:
                                self.conn.send(b'Credenziali corrette!')
                                self.setScope("logincorrect", username)
                                self.friends.append(self)
                                continue
                            else:
                                self.conn.send(b'Password errata')
                        except KeyError:
                            self.conn.send(b'Username non esistente')
                else:
                    self.conn.send(b'Comando non esistente')

            else:
                # not a command
                for friend in self.friends:
                    pieces = message.split("|")
                    if(len(pieces)== 0):
                        continue

                    strToSend = "{}: {}".format(pieces[0], pieces[1])
                    if(friend != self):
                        friend.getClient().send(strToSend.encode('utf-8'))

    def doLogin(self):
        self.setScope("login")
        self.getClient().send(b'Inserisci username e password in questo formato `username:password`\n')

    def setScope(self, scope, username = ""):
        if(self.scopes[scope]):
            if(scope == "logincorrect"):
                self.currentScope = self.scopes[scope]
                send = "!logincorrect:"+username+":[global]"
                self.conn.send(send.encode('utf-8'))
            else:
                self.currentScope = self.scopes[scope]
                role = '!newscope:'+self.scopes[scope]
                self.conn.sendall(role.encode('utf-8'))
                return True
        else:
            return False

    def getScope(self):
        return self.currentScope

    def getClient(self):
        return self.conn
