# Server

import threading
import socket
import json
from ChannelManager import ChannelManager
from ClientHandler import Client
from MySQL import MySQL

class Server:
    def __init__(self, host, port):
        self.host       = host
        self.port       = port
        self.db         = MySQL('localhost', 'chat', 'chat_user', 'test')
        self.connection = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.connection.bind((self.host, self.port))
        self.connection.listen(100)
        self.clients = []
        self.availableChannels = "Canali disponibili:\n"
        self.enabled = False
        self.channels = None
        self.channelsList = []
        self.sessions = self.db.query("SELECT * FROM Sessions") # handling sessions from an array of dict is faster

        with open('data/config.json') as f:
            self.channels = json.load(f)
            i = 1
            for channel in self.channels:
                self.availableChannels += str(i) + ". " + channel + "\n"
                i += 1

        self.channelManager = ChannelManager(self.channels)
        self.enabled = True

        try:
            while self.enabled:
                print("Waiting for a connection...")
                conn, addr = self.connection.accept()
                c = Client(conn, addr, self.clients, self.availableChannels, self.channelManager)
                if c not in self.clients:
                    c.doLogin()

                    self.clients.append(c)
                    #c.getClient().sendall(self.availableChannels.encode('utf-8'))
                    print(addr, 'connected')
                    c.start()

        except (KeyboardInterrupt, SystemExit):
            print("Waiting for threads to stop...")
            self.disable()
            for client in self.clients:
                client.getClient().close()
                self.clients.pop(self.clients.index(client))

    def disable(self):
        self.enabled = False
